/*
 * GpioView.java
 * 
 * Copyright (c) 2003-2004 Digi International
 * This program and the information contained in it is confidential and
 * proprietary to Digi International and may not be used, copied, or re-
 * produced without the prior written permission of Digi International.
 * 
 */

package com.digi.config.ui;

import com.digi.config.core.*;
import com.digi.config.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;




/** 
 * This class is a view panel that shows the current GPIO 
 * configuration settings for the ConnectME device.
 * 
 * This view can be embedded in other panels as desired.
 */


public class GpioView extends ConfigViewImpl {
    /** A KvpNode that holds just the settings used in this view */
    KvpNode viewSettingTree;
    /** listens to the device for changes to settings */
    DeviceChangeListener settingChangeListener;
    /** listens for changes in the UI controls */
    ControlChangeAdapter fieldListener;
    /** Panel that holds the view content */
    GridContentPanel content;

    // Data Fields currently used in this view
    KvpField pinKvpField[];

    // UI Controls for each field
    JComboBox pin_UIC[];

    /**
     * Basic constructor. Sets up the tree view and the edit panel.
     */
    public GpioView() throws Exception {
        super(true);
        // Create the panel that will hold the view controls
        content = new GridContentPanel(this.getName(),1);
        // create the KvpNode and the change listener
        viewSettingTree = new KvpNode();
        settingChangeListener = new DeviceChangeListener() {
            public void deviceChanged(DeviceChangeEvent e) {
                //SystemLog.debug("GpioView was notified that device kvpGroup changed");
                refreshViewData();
                refreshViewControls();
            }
        };
        // Create the panel that will hold the view controls
        content = new GridContentPanel(this.getName(),1);
        // create a listener that will detect when a user edits the field values
        fieldListener = new ControlChangeAdapter() {
            public void changePerformed(Object source, ActionEvent ae, FocusEvent fe) {
                //SystemLog.debug("GpioView was notified that field "+source.toString()+" changed.");
                for (int i=0;i<pin_UIC.length; i++) {
                    if (source==pin_UIC[i]) {
                        pinKvpField[i].setStringValue(pin_UIC[i].getSelectedItem().toString());
                    }
                }
            }
        };


        createViewContent();
    }

    /**
     * Builds the controls on the view. This method builds the view content based
     * upon the capabilities of device we are connected to. If we are not connected to a
     * device, then an empty page is created. This method should be called whenever
     * changing the device this view is connected to because the view content varies
     * per device.
     */
    private void createViewContent()  {
        // Create the panel that will hold the view controls
        content = new GridContentPanel(this.getName(),1);

        if (device==null) {
            return;
        }

        // Allocate dynamically sized setting and control arrays
        pinKvpField = new KvpNode[device.getDeviceModelInfo().getGpioCount()];
        pin_UIC = new JComboBox[device.getDeviceModelInfo().getGpioCount()];


        // Create the fields and put them on the view
        content.addTextLine("GpioViewDesc");

        String pinChoices[] = {
            "in", "out", "serial"
        };
        for (int i=0; i<device.getDeviceModelInfo().getGpioCount(); i++) {
            pin_UIC[i] = content.addJComboBox("GpioPin"+(i+1),"GpioPin"+(i+1)+"Desc",pinChoices,fieldListener);
        }

        content.addVGlue();
    }

    /**
     * Returns a one word name identifying this view. 
     */
    public String getName() {
        return "GpioView";
    }

    /** 
     * Return the Component that displays the primary content for this view
     */
    public Component getViewContent() {
        return content;
    }


    /**
     * Informs view what device to work with. View should flush any
     * cached device data and mark current view content as invalid
     * so that it is refreshed appropriatly.
     */
    public void setDevice(Device device) {
        super.setDevice(device);
        createViewContent();
        refreshViewData();
        refreshViewControls();
        device.addSettingChangeListener(settingChangeListener);
    }

    /** 
     * Refreshes the local copy of the kvpGroup displayed in the view. The updated kvpGroup come
     * from those currently cached in the Device
     */
    private void refreshViewData() {
        viewSettingTree.clear();
        KvpNode gpioModeSettings = viewSettingTree.mergeChild(device.getInternalSettingTree().getChild("gpio_mode"),true);
        if (gpioModeSettings!=null) {
            for (int i=0;i<device.getDeviceModelInfo().getGpioCount(); i++) {
                pinKvpField[i] = gpioModeSettings.getChild("pin"+(i+1)); 
            }
        }
    }

    /** 
     * Refreshes the state of the controls in the view to match the data in the views kvpGroup.
     */
    private void refreshViewControls() {
        if (device!=null) {
            for (int i=0;i<device.getDeviceModelInfo().getGpioCount(); i++) {
                pin_UIC[i].setEnabled(pinKvpField[i]!=null);
                if (pinKvpField[i]!=null) {
                    pin_UIC[i].setSelectedItem(pinKvpField[i].getStringValue());
                }
            }
        }
    }


    /**
     * This method is called to instruct the view that it is about to be made
     * active. When a view is active it needs to make sure its content is correct.
     * An example of why a panel may be inactive is if it were on a tabbed pane 
     * and was not currently visible or if the user selected some other view.
     */
    public void activate() {
        SystemLog.debug("Activating "+getName());
    }

    /**
     * This method is called to instruct the view that it is about to be made
     * inactive. When a view is inactive, it does not need to worry
     * about maintaining its content in a correct state. An example of why a panel
     * may be inactive is if it were on a tabbed pane and was not currently visible
     * or if the user selected some other view.
     */
    public void deactivate() {
        SystemLog.debug("Deactivating "+getName());
    }

    /**
     * Indicates if any changes have been made by the user that have not yet been
     * saved to the device(ie committed).
     */
    public boolean isChanged() {
        return viewSettingTree.hasChanged();
    }

    /**
     * This method instructs the view to validate any of the changes the user has made
     * within the view. Any errors are to be added to the provided errorList. 
     * 
     * @param errorList is a collection of ViewValidationError objects
     */
    public void validateChanges(Collection errorList) {
        // Nothing to Validate
        // errorList.add(new ValidationError("DummyValidationError"));
    }

    /**
     * This method instructs the view to place any changes the user has made within 
     * the view into the provided clusters. Once the changes have been saved to
     * to the device, a subsequent call to commitChanges() will be made.
     */
    public void getChanges(KvpNode settingCluster, KvpNode stateCluster) {
        // Merge the view changes into the provided cluster
        settingCluster.merge(viewSettingTree, false);
    }

    /**
     * Instructs the view to consider any user changes within the view as 
     * saved to the device (ie committed).
     */
    public void commitChanges() {
        // simply reset flags indicating user changes in the contols
        viewSettingTree.resetChanged();
    }

    /** 
     * Instructs the view to discard any changes the user has made within the
     * view and revert those fields to the original state. The view is also 
     * free to refresh all its fields to the present cached state of the device at 
     * this time.
     */
    public void cancelChanges() {
        refreshViewData();
        refreshViewControls();
    }


}


